package org.processmining.streamconformance.local.model;

import org.processmining.framework.util.Pair;

/**
 * This class represents a direct following relationship between two activities.
 * 
 * @author Andrea Burattin
 */
public class DirectFollowingRelation extends Pair<String, String> {

	/**
	 * Construct a direct following relation between the two activities
	 * 
	 * @param first
	 * @param second
	 */
	public DirectFollowingRelation(String first, String second) {
		super(first, second);
	}

	@Override
	public String toString() {
		return first + " > " + second;
	}
}
