package org.processmining.streamconformance.regions.gui.panels;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.JPanel;
import javax.swing.JTextField;

import org.processmining.streamconformance.regions.utils.GUICustomUtils;

public class CostsSetup extends JPanel {

	private static final long serialVersionUID = -7669190410170225552L;
	private JTextField fieldCost;
	private JTextField fieldCostExtraActivity;

	/**
	 * Basic class constructor
	 */
	public CostsSetup() {
		initComponents();
	}

	public int getCostWrongFlow() {
		return Integer.parseInt(fieldCost.getText());
	}

	public int getCostActivityNotInProcess() {
		return Integer.parseInt(fieldCostExtraActivity.getText());
	}

	/*
	 * Graphical components initializer
	 */
	private void initComponents() {
		fieldCost = GUICustomUtils.prepareIntegerField(100);
		fieldCostExtraActivity = GUICustomUtils.prepareIntegerField(100);
		GridBagConstraints c = new GridBagConstraints();

		setOpaque(false);
		setLayout(new GridBagLayout());

		c.gridx = 0;
		c.gridy = 0;
		c.gridwidth = 2;
		c.insets = new Insets(0, 0, 15, 0);
		c.fill = GridBagConstraints.HORIZONTAL;
		add(GUICustomUtils.prepareLabel("Use this form to configure costs of the extended coverability graph."), c);

		c.gridx = 0;
		c.gridy = 1;
		c.insets = new Insets(0, 0, 5, 0);
		add(GUICustomUtils.prepareLabel("Cost of wrong flow:"), c);

		c = new GridBagConstraints();
		c.gridx = 1;
		c.gridy = 1;
		c.weightx = 1;
		c.fill = GridBagConstraints.HORIZONTAL;
		c.insets = new Insets(0, 5, 5, 0);
		add(GUICustomUtils.wrapInRoundedPanel(fieldCost), c);

		c = new GridBagConstraints();
		c.gridx = 0;
		c.gridy = 2;
		c.anchor = GridBagConstraints.NORTH;
		c.insets = new Insets(5, 0, 5, 0);
		add(GUICustomUtils.prepareLabel("Cost of activity not in process:"), c);

		c = new GridBagConstraints();
		c.gridx = 1;
		c.gridy = 2;
		c.weightx = 1;
		c.weighty = 1;
		c.fill = GridBagConstraints.HORIZONTAL;
		c.anchor = GridBagConstraints.NORTH;
		c.insets = new Insets(0, 5, 5, 0);
		add(GUICustomUtils.wrapInRoundedPanel(fieldCostExtraActivity), c);
	}
}
