package org.processmining.streamconformance.regions.plugin.analysis;

import java.net.InetAddress;

import org.processmining.framework.annotations.AuthoredType;
import org.processmining.models.graphbased.directed.DirectedGraphElementWeights;
import org.processmining.models.graphbased.directed.transitionsystem.AcceptStateSet;
import org.processmining.models.graphbased.directed.transitionsystem.CoverabilityGraph;
import org.processmining.models.graphbased.directed.transitionsystem.StartStateSet;
import org.processmining.streamconformance.regions.plugin.cg.ExtendedCoverabilityGraph;

@AuthoredType(
		typeName = "Online Conformance Configuration",
		author = "A. Burattin",
		email = "",
		affiliation = "DTU")
public class OnlineConformanceConfiguration {

	protected CoverabilityGraph originalModel;
	protected ExtendedCoverabilityGraph model;
	protected DirectedGraphElementWeights weights;
	protected StartStateSet startIds;
	protected AcceptStateSet acceptIds;
	protected int port;
	protected InetAddress address;
	protected int noMaxParallelInstances;
	protected int backtrackingSteps;
	protected int noErorrsPerTrace;
	protected int noErrorsMostFrequent;

	public AcceptStateSet getAcceptIds() {
		return acceptIds;
	}

	public InetAddress getAddress() {
		return address;
	}

	public ExtendedCoverabilityGraph getModel() {
		return model;
	}

	public int getPort() {
		return port;
	}

	public StartStateSet getStartIds() {
		return startIds;
	}

	public DirectedGraphElementWeights getWeights() {
		return weights;
	}

	public void setAcceptIds(AcceptStateSet acceptIds) {
		this.acceptIds = acceptIds;
	}

	public void setAddress(InetAddress address) {
		this.address = address;
	}

	public void setModel(ExtendedCoverabilityGraph model) {
		this.model = model;
	}

	public void setPort(int port) {
		this.port = port;
	}

	public void setStartIds(StartStateSet startIds) {
		this.startIds = startIds;
	}

	public void setWeights(DirectedGraphElementWeights weights) {
		this.weights = weights;
	}

	public CoverabilityGraph getOriginalModel() {
		return originalModel;
	}

	public void setOriginalModel(CoverabilityGraph originalModel) {
		this.originalModel = originalModel;
	}

	public int getBacktrackingSteps() {
		return backtrackingSteps;
	}

	public void setBacktrackingSteps(int backtrackingSteps) {
		this.backtrackingSteps = backtrackingSteps;
	}

	public int getNoErorrsPerTrace() {
		return noErorrsPerTrace;
	}

	public void setNoErorrsPerTrace(int noErorrsPerTrace) {
		this.noErorrsPerTrace = noErorrsPerTrace;
	}

	public int getNoErrorsMostFrequent() {
		return noErrorsMostFrequent;
	}

	public void setNoErrorsMostFrequent(int noErrorsMostFrequent) {
		this.noErrorsMostFrequent = noErrorsMostFrequent;
	}

	public int getNoMaxParallelInstances() {
		return noMaxParallelInstances;
	}

	public void setNoMaxParallelInstances(int noMaxParallelInstances) {
		this.noMaxParallelInstances = noMaxParallelInstances;
	}
}
